Subject: Re: [RFC] New command: git-recall -- a developer standup/activity tool

From: Tian Yuchen <[email-masked]>
Date: Tue, 14 Apr 2026 02:07:16 +0800

Hi Amar,

On 4/13/26 07:43, AMMAAAR BAKSHI wrote:
> Hi,
> 
> I'd like to propose a new command: `git recall`.
> 
> ## Motivation
> 
> Developers often need a quick way to review what they (or their team)
> committed recently -- for standups, weekly summaries, or general
> self-review. 

Standups, weekly summaries or general self-review...? These feel more 
like workflow conveniences — is a built-in command really the right 
place for them?

> Currently this requires constructing a `git log` invocation
> with --author, --since, --oneline, and formatting flags, which is
> non-obvious for casual users.

Adding a line like 'standup = log --since=yesterday --author=...' in 
'.gitconfig' is another nice way of achieving this ;-)

> 
> ## Proposal
> 
> `git recall` would be a porcelain command that shows a formatted
> summary of recent commits, grouped by date:
> 
>    git recall              # last 1 week (default)
>    git recall --day        # last 1 day
>    git recall --week -2    # last 2 weeks
>    git recall --month      # last 1 month
>    git recall --year       # last 1 year
> 
> Example output:
> 
>    --------------------------------------------------
>      git recall  --  Last Week  (since 2026-04-06)
>    --------------------------------------------------
>      2026-04-11
>      448e66e  Add login page  @ 19:41  Alice
>      2026-04-10
>      91bc3fa  Fix null pointer  @ 14:22  Bob
>    --------------------------------------------------
>      Total commits: 2
>    --------------------------------------------------
> 
> ## Implementation
> 
> I have a working standalone implementation in pure C with no
> dependencies, available at:
> 
>    https://github.com/AMMAAR-IC/git-recall
> 

Good to hear that;

> It currently runs as an external binary (git-recall). I am interested
> in contributing this as a built-in Git subcommand if the community
> finds the idea worthwhile.
> 
> I am aware that similar output can be produced via:
> 
>    git log --oneline --since=1.week.ago --author=$(git config user.name)
> 
> However, git recall aims to provide a more discoverable, human-friendly
> interface for this common workflow, similar to how `git switch` and
> `git restore` were introduced to simplify `git checkout`.

I suppose the 'checkout' command was split up and simplified because its 
meaning isn’t particularly intuitive for ordinary users, is it? 'git 
log', on the other hand, is, in my view, a very clear and 
straightforward read-only command.

You said this is a more discoverable and human-fridenly interface. If 
that’s the case, I think we should compare the merits of this method 
with defining aliases directly in .gitconfig.

> 
> ## Questions for the community
> 
> 1. Is this functionality considered within scope for a built-in command?

I don’t think it should be a built-in command.

> 2. Would `git recall` be an appropriate name, or would something like
>     `git activity` or `git standup` be preferred?

To be honest, the name 'recall' is a bit odd.

According to dictionary.cambridge.org, 'recall' has at least two 
meanings. I think this is your intention:

"...to bring the memory of a past event into your mind, and often to 
give a description of what you remember..."

However,

"...to order the return of a person who belongs to an organization or of 
products made by a company..."

is another valid meaning. We say "recall an email" "recall defective 
products". This suggests that the word carries a connotation of 
amendment/revocation. However, based on your description, this is a 
*read-only* operation, right?

If a "casual user" sees this command name, might he think: "This is a 
logging command, but why is it called 'recall'? Will it alter my commit 
history? Could there be other side effects?" This is something we need 
to think about.

> 3. Are there existing plans or discussions around a similar feature?
> 
> I am happy to write a proper patch series if the idea is well-received.
> 
> Thank you for your time.
> 
> Ammaar Bakshi
> https://github.com/AMMAAR-IC/git-recall

Thanks, Yuchen